<template>
  <div class="container">
    <h2>Custom Registration</h2>

    <form>
      <div class="form-group">
        <label for="name">Name:</label>
        <input type="text"
               class="form-control"
               id="name"
               v-model="name"/>
      </div>

      <div class="form-group">
        <label for="mobile">Mobile #:</label>
        <input type="text"
               class="form-control"
               id="mobile"
               v-model="mobileNumber"/>
      </div>
    </form>

    <div class="btn-toolbar">
      <button class="btn btn-warning"
              @click="handleReset">
        Reset
      </button>
      <button class="btn btn-primary"
              @click="handleSubmit">
        Submit
      </button>
    </div>

  </div>
</template>

<script>
  import APIHelper from '../api-helper'

  export default {
    name: "RegistrationPage",
    data() {
      return {
        name: null,
        mobileNumber: null
      }
    },
    methods: {
      handleReset() {

      },
      handleSubmit() {
        if (this.name && this.mobileNumber) {
          APIHelper.enqueue(this.name, this.mobileNumber)
            .then((num) => {
              const url = `/queue/?name=${encodeURIComponent(this.name)}&n=${encodeURIComponent(num)}`;
              this.$router.push(url);
            })
            .catch(err => {
              console.error(err);
              alert('Error submitting form');
            });
        } else {
          alert('All fields are required');
        }
      }
    }
  }
</script>

<style scoped>
  .btn-toolbar .btn {
    margin-right: 10px;
  }
</style>